package com.asset.controller.system;

import com.asset.common.Common;
import com.asset.common.ResultUtil;
import com.asset.common.Sms;
import com.asset.domain.Result;
import com.asset.domain.system.Code;
import com.asset.enums.CodeEnum;
import com.asset.service.system.CodeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import java.io.*;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

/*
 * @author xiaol
 * @date 2020/3/23
 */
@RestController
@RequestMapping(value = "/sms")
public class SmsController {

    @Autowired
    CodeService codeService;

    //消息模板
    private static String msg = "您正在申请修改中国e车会员密码，验证码是：${verifyCode}，请勿将验证码告知他人！";

    @GetMapping("/sendSmsChangePassword")
    public Result sendSmsChangePassword(String phone) throws IOException {
        String verifyCode = String.valueOf(new Random().nextInt(899999) + 100000);
        Map m = new HashMap();
        m.put("verifyCode", verifyCode);
        String passwordMsg = Common.freemarkerProcess(m, msg);
        String re = Sms.sendSms(phone,passwordMsg);
        if(Integer.parseInt(re) == 0){
            String ex = Common.getDateToString(Common.getTime() + 2*60*1000);
            //发送成功短信验证码入库
            Code co = new Code();
            co.setPhone(phone);
            co.setCode(verifyCode);
            co.setExpire(ex);
            codeService.save(co);
            return ResultUtil.success(CodeEnum.SUCCESS);
        }else{
            return ResultUtil.success(CodeEnum.ERROR);
        }
    }

    /*
    private static String url = "http://send.18sms.com/msg/HttpBatchSendSM";
    private static String account = "tbnn30";
    private static String pswd = "Zgec1234";
    private static String phone = "18814820090";

    @GetMapping("/sendSms")
    public String sendSms() throws IOException {
        HttpClient client = new HttpClient();
        PostMethod post = new PostMethod("http://send.18sms.com/msg/HttpBatchSendSM");
        post.addRequestHeader("Content-Type",
                "application/x-www-form-urlencoded;charset=UTF-8");// 在头文件中设置转码
        NameValuePair[] data = { new NameValuePair("account", account), // 注册的用户名
                new NameValuePair("pswd", pswd), // 注册成功后,登录网站使用的密钥
                new NameValuePair("mobile", phone), // 手机号码
                new NameValuePair("msg", msg) };
        post.setRequestBody(data);

        client.executeMethod(post);
        Header[] headers = post.getResponseHeaders();
        int statusCode = post.getStatusCode();
        System.out.println("statusCode:" + statusCode);
        for (Header h : headers) {
            System.out.println(h.toString());
        }
        String result = new String(post.getResponseBodyAsString().getBytes(
                "UTF-8"));
        System.out.println(result);
        post.releaseConnection();
        return result;
    }
    */

}
